#!/bin/bash
# for puppy linux (woof based) only!
# (c)copyright Mick Amadio 2013 <01micko@gmail.com>
# GPL V2 or later at your discretion
# see /usr/share/doc/legal/
# ****************************************************************************# 
# called from /usr/sbin/xorgwizard-automatic on condition that the 
# kernel is >=3.3 and that the vendor ID of the video chipset is 8086 (Intel)
# Filters out cedarview/poulsbo device ID
# if matched the /usr/lib/x/drivers-alternate/modesetting_drv.so
# is moved to /usr/lib/xorg/modules/drivers/
# ****************************************************************************# 

# version 0.1 130115

# the device ID's, we create a database in /tmp
echo '0be0  Cedarview Integrated Graphics Controller
0be1  Cedarview Integrated Graphics Controller
0be2  Cedarview Integrated Graphics Controller
0be3  Cedarview Integrated Graphics Controller
0be4  Cedarview Integrated Graphics Controller
0be5  Cedarview Integrated Graphics Controller
0be6  Cedarview Integrated Graphics Controller
0be7  Cedarview Integrated Graphics Controller
0be8  Cedarview Integrated Graphics Controller
0be9  Cedarview Integrated Graphics Controller
0bea  Cedarview Integrated Graphics Controller
0beb  Cedarview Integrated Graphics Controller
0bec  Cedarview Integrated Graphics Controller
0bed  Cedarview Integrated Graphics Controller
0bee  Cedarview Integrated Graphics Controller
0bef  Cedarview Integrated Graphics Controller
8108  System Controller Hub (SCH Poulsbo) Graphics Controller' >/tmp/poulsbo
BASE=/tmp/poulsbo

# now get the device ID
DEV_ID=$(lspci -nn|grep -iE vga|tr ' ' '\n'|grep '[0-9a-f][0-9a-f][0-9a-f][0-9a-f]:'|cut -d ':' -f2|tr -d ']') #needs testing
while read LINE;do 
  MATCH=$(echo "$LINE"|grep $DEV_ID)
  if [ "$MATCH" ];then 
    if [ -f /usr/lib/x/drivers-alternate/modesetting_drv.so ];then
      mv -f /usr/lib/x/drivers-alternate/modesetting_drv.so /usr/lib/xorg/modules/drivers/ #move if matched, if there
      modprobe gma500-gfx # note: Medfield unsupported
      echo "modesetting xorg driver is now enabled" #tell the user
      echo "1" /tmp/poulsbo.flg
      break
        else echo "modesetting xorg driver NOT FOUND"
        break
    fi
    else continue
  fi
 done<$BASE
rm $BASE #cleanup
# back to xorgwizard-automatic
